/**************************************************************************
*
*  Description:
*
*
*
*
***************************************************************************
*  Filename: DateTime.h
***************************************************************************
*    $State$
***************************************************************************
*
*  Remarks :
*
***************************************************************************
*
*  History :
*  Revision  x.xx  JJJJ/MM/DD tt:mm:ss  Author
*  ------------------------------------------------------------------------
* $Revision$, $Name$
*
* $Log$
*
* Alexey.Govorukhin 09.10.2008
*
**************************************************************************/
#if !defined(__DateTime_h)
#define __DateTime_h

#include "types.h"

#ifdef __DateTime_c
#define GLOBAL
#else
#define GLOBAL extern
#endif

#ifdef __cplusplus
extern "C"
{
#endif
/**************************************************************************
* definitions
**************************************************************************/
//#error DateTime
typedef union TDateTime {
 struct {
   u08  bSec   :6; // 0 - 63
   u08  bMin   :6; // 0 - 63
   u08  bHour  :5; // 0 - 31
   u08  bDay   :5; // 0 - 31
   u08  bMonth :4; // 0 - 15
   u08  bYear  :6; // 0 - 63 - 2000 + X
 } Date;
 struct {
   u32 dwValue;
 } All;
} PACKED TDateTime;  // 32

typedef struct {
   u08  bSec   ; // 0 - 63
   u08  bMin   ; // 0 - 63
   u08  bHour  ; // 0 - 31
   u08  bDay   ; // 0 - 31
   u08  bMonth ; // 0 - 15
   u08  bYear  ; // 0 - 63
} TDateTimeW;
/**************************************************************************
* declarations
**************************************************************************/

GLOBAL TDateTime DateTime;

/**************************************************************************
* function prototypes
**************************************************************************/

char CompareDateTime( TDateTime * DateTime1, TDateTime * DateTime2 );

void SetDateTime( TDateTime * SrcDT );

void DateTimeTrigger(void);

void SecondsToDateTime( TDateTimeW * pDTW, u32 dwSecs );

#ifdef __cplusplus
}
#endif

#undef GLOBAL
#endif /* __DateTime_h  */
/*********************************** EOF *********************************/
