/**************************************************************************
*
*  Description:   CRC Calculation procedures
 * Name:          fcs.h
 * Purpose:
 * Author:        MasterAlexei (MasterAlexei@gmail.com)
 * Created:
 * Copyright:     MasterAlexei (http://www.fun-electronic.net/)
 *
 * License:
 *
 *  Copyright (c) 2005-2009 by Govorukhin Alexey
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of the author nor the names of its contributors may
 *     be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 *  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 *  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 *  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 *  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *  SUCH DAMAGE.
 *
 ****************************************************************************/

#if !defined(__FCS_H__)
#define __FCS_H__



/**************************************************************************
* definitions
**************************************************************************/

#ifdef SDCC
#ifndef register
#define register
#endif

#endif

#ifdef __cplusplus
extern "C"
{
#endif

/**************************************************************************
* declarations
**************************************************************************/

/**************************************************************************
* implementation
**************************************************************************/

/**************************************************************************
* function prototypes
**************************************************************************/



u16 CalculateCRC(register u08* pDatenbyte, register u16  wCnt);

void CopyBack(u08 * bBuffer, u16 wLen);

u16 PreparePacketToTransfer(u08 * bBuffer, u16 wLen);

u16 SetStartStopsBytes(u08 * bBuffer, u16 wLen);

u16 CalculateCRCI(register u08* pDatenbyte, register u16  wCnt, u16 wInitVal );

#ifdef __cplusplus
}
#endif

#undef GLOBAL
#endif // __FCS_H__
/*********************************** EOF *********************************/
