/**************************************************************************
*
*  Description: software timers header
*
*  Copyright (c) 2005-2009 by Govorukhin Alexey
*
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions
*  are met:
*
*  1. Redistributions of source code must retain the above copyright
*     notice, this list of conditions and the following disclaimer.
*  2. Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in the
*     documentation and/or other materials provided with the distribution.
*  3. Neither the name of the author nor the names of its contributors may
*     be used to endorse or promote products derived from this software
*     without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
*  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
*  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
*  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
*  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGE.
*
*
***************************************************************************
*  Filename: timer.h
***************************************************************************
*
**************************************************************************/
#if !defined(__timer_h)
#define __timer_h

//#if defined(__WXMSW__) || defined(__WXGTK__)
#include "TimerDefs.h"
//#endif

#ifdef __timer_c
#define GLOBAL
#else
#define GLOBAL extern
#endif

#ifdef __cplusplus
extern "C"
{
#endif

/**************************************************************************
* definitions
**************************************************************************/


typedef struct {
 u32 TimerVar;
 u08 Flag;
 u08 Enabled;
} TSWTimer;

/**************************************************************************
* declarations
**************************************************************************/



/**************************************************************************
* function prototypes
**************************************************************************/

void SWTInit(void);

void SWTLoad(u08 bTimer, u32 dwTime);

u08 SWTEnabled(u08 bTimer);

u08 SWTFlag(u08 bTimer);

void SWTClear(u08 bTimer);

void SWTStop(u08 bTimer);

void SWTResume(u08 bTimer);

void SWTTrigger(void);

u32 inline GetTickCount(void);

void inline SetTickCount(u32 nTicks);

#ifdef __cplusplus
}
#endif

#undef GLOBAL
#endif /* __timer_h  */
/*********************************** EOF *********************************/
