/***************************************************************
 * Name:      types.h
 * Purpose:
 * Author:    MasterAlexei (MasterAlexei@gmail.com)
 * Created:
 * Copyright: MasterAlexei (http://www.fun-electronic.net/)
 *
 * License:
 *
 *  Copyright (c) 2005-2009 by Govorukhin Alexey
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of the author nor the names of its contributors may
 *     be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 *  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 *  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 *  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 *  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *  SUCH DAMAGE.
 *
 ****************************************************************************/

#ifndef __TYPES_H__
#define __TYPES_H__

#if defined(__WXMSW__) || defined(__WXGTK__) || defined(__GNUC__)

 #define PACKED __attribute__((packed))

#else
//#error PACKED

 #define PACKED

#endif

#ifdef SDCC
 #ifndef register
  #define register
 #endif
#endif



//
// easy to type types, type
//                                s
typedef unsigned char  u08;
typedef unsigned short u16;
typedef unsigned long  u32;

typedef char  s08;
typedef short s16;
typedef long  s32;

#ifndef u16bytes
typedef struct
{
	u08 low, high;
} u16bytes;
#endif

#ifndef u16convert
typedef union
{
	u16 value;
	u16bytes bytes;
} u16convert;
#endif

#ifndef u32bytes
typedef struct
{
	u08 byte1, byte2, byte3, byte4;
}u32bytes;
#endif

#ifndef u32words
typedef struct
{
	u16 low, high ;
}u32words;
#endif

#ifndef u32convert
typedef union
{
	u32 value;
	u32bytes bytes;
	u32words words;
} u32convert;
#endif

//#define NULL    0

#ifndef ON
#define ON  1
#endif

#ifndef OFF
#define OFF 0
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE  1
#endif

#ifndef false
#define false 0
#endif

#ifndef true
#define true  1
#endif

#ifndef UNBLOCK
#define UNBLOCK 0
#endif

#ifndef BLOCK
#define BLOCK 1
#endif

#if defined(_AVR_GCC)
// || defined(__WXMSW__)

#ifndef BIT
typedef char                BIT;
#endif


#define code const

#ifndef CHAR
typedef char               CHAR;
#endif

#ifndef BYTE
typedef unsigned char      BYTE;
#endif

#ifndef SHORT
typedef short              SHORT;
#endif


#ifndef WORD
typedef unsigned short     WORD;
#endif


#ifndef LONG
typedef long               LONG;
#else
#  pragma foreign_LONG_type
#endif


#ifndef DWORD
typedef unsigned long      DWORD;
#else
#  pragma foreign_DWORD_type
#endif


#ifndef FLOAT
typedef float              FLOAT;
#else
#  pragma foreign_FLOAT_type
#endif

#ifndef DOUBLE
typedef double             DOUBLE;
#else
//#  pragma foreign_DOUBLE_type
#endif

#ifndef double
#define double float
#endif

#endif // _AVR_GCC


//
// some max values
//

#define MAX_U32 ((u32)0xFFFFFFFFL)
#define MAX_U16 ((u16)0xFFFFL)
#define MAX_U08 ((u08)0xFFL)

#define MAX_S16  32767
#define MIN_S16  -32768

#ifndef NULL
#define NULL ((void *)0)
#endif

#endif
