/**************************************************************************
*
*  Description:
*
*
*
*
***************************************************************************
*  Filename: DateTime.c
***************************************************************************
*    $State$
***************************************************************************
*
*  Remarks :
*
***************************************************************************
*
*  History :
*  Revision  x.xx  JJJJ/MM/DD tt:mm:ss  Author
*  ------------------------------------------------------------------------
* $Revision$, $Name$
*
* $Log$
*
* Alexey.Govorukhin 09.10.2008
*
**************************************************************************/
#if !defined(__DateTime_c)
#define __DateTime_c

#include "types.h"
#include "DateTime.h"
//#include "incfiles.h"


/**************************************************************************
* definitions
**************************************************************************/


/**************************************************************************
* declarations
**************************************************************************/


u08 DaysInMonth[12]={31,28,31,30,31,30,31,31,30,31,30,31};

/**************************************************************************
* function prototypes
**************************************************************************/


/**************************************************************************
* implementation
**************************************************************************/
u08 RTC_IsLeapYear(u32 year)
{
   if(year < 1601)
   { //if the year is divisible by 4, it's a leap year
      if(!(year % 4))
         return 1;
   }
   else //year is 1601 or later
   { //if the year is divisible by 4 and either not divisible by
     //100 or divisible by 400, then it is a leap year
     if(!(year % 4) && ((year % 100) || !(year % 400)))
        return 1; //indicate leap year
     //otherwise the year is not a leap year
     else
        return 0; //indicate a normal year
   }
   return 0;
}


char CompareDateTime( TDateTime * DateTime1, TDateTime * DateTime2 )
{
  char bRes = 0;

  if ( DateTime1->Date.bYear > DateTime2->Date.bYear )
  {
    bRes = 1;
  }
  else if ( DateTime1->Date.bYear < DateTime2->Date.bYear )
  {
    bRes = -1;
  }
  else
  {
    if ( DateTime1->Date.bMonth > DateTime2->Date.bMonth )
    {
      bRes = 1;
    }
    else if ( DateTime1->Date.bMonth < DateTime2->Date.bMonth )
    {
      bRes = -1;
    }
    else
    {
      if ( DateTime1->Date.bDay > DateTime2->Date.bDay )
      {
        bRes = 1;
      }
      else if ( DateTime1->Date.bDay < DateTime2->Date.bDay )
      {
        bRes = -1;
      }
      else
      {
        if ( DateTime1->Date.bHour > DateTime2->Date.bHour )
        {
          bRes = 1;
        }
        else if ( DateTime1->Date.bHour < DateTime2->Date.bHour )
        {
          bRes = -1;
        }
        else
        {
          if ( DateTime1->Date.bMin > DateTime2->Date.bMin )
          {
            bRes = 1;
          }
          else if ( DateTime1->Date.bMin < DateTime2->Date.bMin )
          {
            bRes = -1;
          }
          else
          {
            if ( DateTime1->Date.bSec > DateTime2->Date.bSec )
            {
              bRes = 1;
            }
            else if ( DateTime1->Date.bSec < DateTime2->Date.bSec )
            {
              bRes = -1;
            }
          }
        }
      }
    }
  }
  return(bRes);
}

void SetDateTime( TDateTime * SrcDT )
{
  DateTime.All.dwValue = SrcDT->All.dwValue;
}

void DateTimeTrigger(void)
{
  /*
   u08  bSec   :6; // 0 - 63
   u08  bMin   :6; // 0 - 63
   u08  bHour  :5; // 0 - 31
   u08  bDay   :5; // 0 - 31
   u08  bMonth :4; // 0 - 15
   u08  bYear  :8; // 0 - 255 - 2000 + X
  */


  if( DateTime.Date.bSec < 59 )
    DateTime.Date.bSec++;
  else
  {
    DateTime.Date.bSec = 0;
    if( DateTime.Date.bMin < 59 )
      DateTime.Date.bMin++;
    else
    {
      DateTime.Date.bMin = 0;
      if( DateTime.Date.bHour < 23 )
        DateTime.Date.bHour++;
      else
      {
        DateTime.Date.bHour = 0;
        if ( DateTime.Date.bDay < DaysInMonth[ DateTime.Date.bMonth - 1 ] )
          DateTime.Date.bDay++;
        else
        {
          DateTime.Date.bDay = 1;
          if ( DateTime.Date.bMonth < 12 )
            DateTime.Date.bMonth ++;
          else
          {
            DateTime.Date.bMonth = 1;
            DateTime.Date.bYear++;
          }
          DaysInMonth[1] = 28 + RTC_IsLeapYear( DateTime.Date.bYear + 2000 );
        }
      }
    }
  }


}


void SecondsToDateTime( TDateTimeW * pDTW, u32 dwSecs )
{
  u32 dwValue;
  u32 dwRestSeconds;
  if( pDTW != NULL )
  {
    dwValue = (dwSecs / (365 * 24 * 60 * 60));                // Calc Years
    pDTW->bYear = dwValue;                                    // Store it

    dwRestSeconds = ( dwSecs - (dwValue * (365 * 24 * 60 * 60)) );  // Calc rest of seconds

    dwValue = dwRestSeconds / ( 30 * 24 * 60 * 60 );               // Calc Months
    pDTW->bMonth = dwValue;                                   // Store it

    dwRestSeconds = ( dwRestSeconds - (dwValue * (30 * 24 * 60 * 60)) );  // Calc rest of seconds

    dwValue = dwRestSeconds / ( 24 * 60 * 60 );                     // Calc Days
    pDTW->bDay = dwValue;                                     // Store it

    dwRestSeconds = ( dwRestSeconds - (dwValue * (24 * 60 * 60)) );       // Calc rest of seconds

    dwValue = dwRestSeconds / ( 60 * 60 );                          // Calc Hours
    pDTW->bHour = dwValue;                                    // Store it

    dwRestSeconds = ( dwRestSeconds - (dwValue * (60 * 60)) );            // Calc rest of seconds

    dwValue = dwRestSeconds / ( 60 );                               // Calc minutes
    pDTW->bMin = dwValue;                                     // Store it

    dwRestSeconds = ( dwRestSeconds - (dwValue * (60)) );                 // Calc rest of seconds

    pDTW->bSec = dwRestSeconds;                                     // Store it
  }
}

#endif /* __DateTime_c  */
/*********************************** EOF *********************************/
