/**************************************************************************
*
*  Description:  Software Timers functions
*
*  Copyright (c) 2005-2009 by Govorukhin Alexey
*
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions
*  are met:
*
*  1. Redistributions of source code must retain the above copyright
*     notice, this list of conditions and the following disclaimer.
*  2. Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in the
*     documentation and/or other materials provided with the distribution.
*  3. Neither the name of the author nor the names of its contributors may
*     be used to endorse or promote products derived from this software
*     without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
*  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
*  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
*  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
*  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGE.
*
***************************************************************************
*  Filename: timer.c
***************************************************************************
*
**************************************************************************/
#if !defined(__timer_c)
#define __timer_c

/*
#if !defined(__WXMSW__) && !defined(__WXGTK__) && !defined(_AVRProgrammer_)
#include "incfiles.h"
#else
*/
// #include "struct.h"
#include <string.h>
#include "types.h"
#include "swtimer.h"
//#endif



/**************************************************************************
* definitions
**************************************************************************/


/**************************************************************************
* declarations
**************************************************************************/


static TSWTimer SWTimerVar[ SWT_MAX_TIMER ];
static u32      dwTimerTicks;

/**************************************************************************
* function prototypes
**************************************************************************/


/**************************************************************************
* implementation
**************************************************************************/

u32 inline GetTickCount(void)
{
  return(dwTimerTicks);
}

void inline SetTickCount(u32 nTicks)
{
  dwTimerTicks = nTicks;
}

void SWTInit(void)
{
 u08 i;
 for (i = 0; i < SWT_MAX_TIMER; i++)
 {
   SWTClear(i);
 }
 dwTimerTicks = 0;

}

void SWTLoad(u08 bTimer, u32 dwTime)
{
 /*
 if (bTimer < SWT_MAX_TIMER)
 {
 */
   SWTimerVar[bTimer].TimerVar = dwTime;
   SWTimerVar[bTimer].Flag     = 0;
   SWTimerVar[bTimer].Enabled  = 1;
 //}
}

u08 SWTEnabled(u08 bTimer)
{
  /*
  if (bTimer < SWT_MAX_TIMER)
  {
  */
   return(SWTimerVar[bTimer].Enabled);
   /*
  }
  else
   return(0);
  */
}

u08 SWTFlag(u08 bTimer)
{
  /*
  if (bTimer < SWT_MAX_TIMER)
  {
  */
   return(SWTimerVar[bTimer].Flag);
  /*
  }
  else
   return(1);
  */
}

void SWTClear(u08 bTimer)
{
  /*
  if (bTimer < SWT_MAX_TIMER)
  {
  */
   SWTimerVar[bTimer].Enabled  = 0;
   SWTimerVar[bTimer].Flag     = 0;
   SWTimerVar[bTimer].TimerVar = 0;
  //}
}

void SWTStop(u08 bTimer)
{

  if (bTimer < SWT_MAX_TIMER)
  {
   SWTimerVar[bTimer].Enabled  = 0;
  }

}

void SWTResume(u08 bTimer)
{
  if (bTimer < SWT_MAX_TIMER)
  {
   SWTimerVar[bTimer].Enabled  = 1;
  }
}

void SWTTrigger(void)
{
 u08 i;
 dwTimerTicks++;

 for (i = 0; i < SWT_MAX_TIMER; i++)
 {
   if (SWTimerVar[i].Enabled)
   {
     if (SWTimerVar[i].TimerVar > 0)
     {
       SWTimerVar[i].TimerVar--;
     }
     else
     {
      SWTimerVar[i].Flag     = 1;
      SWTimerVar[i].Enabled  = 0;
     }
   }
 }
}


#endif /* __timer_c  */
/*********************************** EOF *********************************/
