/***************************************************************
 * Name:      WDGComm.h
 * Purpose:   Watchdog communication class
 * Author:    Alexey Govorukhin (MasterAlexei@googlemail.com)
 * Created:   2010
 * Copyright: Alexey Govorukhin (http://www.fun-electronic.net/)
 * License:
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of the author nor the names of its contributors may
 *     be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 *  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 *  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 *  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 *  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *  SUCH DAMAGE.
 *
 **************************************************************************/

#ifndef _WDGCOMM_H
#define _WDGCOMM_H


#include <termios.h>
#include <fcntl.h>
#include <sys/signal.h>

#if defined(_WDGCOMM_C)
#define GLOBAL
#else
#define GLOBAL extern
#endif



/**************************************************************************
* definitions
**************************************************************************/

#define BAUDRATE B19200

class TWDConnect {

  bool fOpened;

  struct termios oldtio, newtio;

  char * pszPortName;

  int PortDsc;

  int nPortNum;
  int nPNLen;

  u16 wRxIndex;
  u08 bRxBuff[ sizeof( TWD_CommData ) + 3 ];
public:
  TWDConnect( char * szPrtNm );
  ~TWDConnect();

  int Open();
  void Close();

  bool IsOpened() { return fOpened; }
  void ReceiveByte( u08 bByte );
  void ProcessData( TWD_CommData * CommData );
  bool SendRequest( TCommCmds Cmd, void * vData );

};

/**************************************************************************
* declarations
**************************************************************************/


/**************************************************************************
* function prototypes
**************************************************************************/


/**************************************************************************
* implementation
**************************************************************************/




#undef GLOBAL
#endif // _WDGCOMM_H
/*********************************** EOF *********************************/

