/***************************************************************
 * Name:      WatchDogConnectMain.cpp
 * Purpose:   WatchDogConnect Main frame class
 * Author:    Alexey Govorukhin (MasterAlexei@googlemail.com)
 * Created:   2010
 * Copyright: Alexey Govorukhin (http://www.fun-electronic.net/)
 * License:
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of the author nor the names of its contributors may
 *     be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 *  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 *  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 *  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 *  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *  SUCH DAMAGE.
 *
 **************************************************************************/

#ifndef WATCHDOGCONNECTMAIN_H
#define WATCHDOGCONNECTMAIN_H


#include <wx/socket.h>
#include <wx/timer.h>

#include "WatchDogConnectApp.h"


#include "GUIFrame.h"


#include "types.h"


typedef enum {
  MainTIMER_ID = 10000,
  WD_SOCKET_ID ,

  MAX_IDs
};

class WatchDogConnectFrame: public TMainFrame
{
  wxTimer * MainTimer;
  wxSocketClient * pWDSocket;


public:
    WatchDogConnectFrame(wxFrame *frame);
    ~WatchDogConnectFrame();
private:
    virtual void OnClose(wxCloseEvent& event);
    virtual void OnQuit(wxCommandEvent& event);
    virtual void OnAbout(wxCommandEvent& event);
    virtual void WatchdogsSettingsMIOnClick( wxCommandEvent& event );

    void OnMainTimer(wxTimerEvent& event);
		virtual void WatchDogCBOnCombobox( wxCommandEvent& event );
		virtual void ConnectWDButtonOnClick( wxCommandEvent& event );
		virtual void DisconnectButtonOnClick( wxCommandEvent& event );
		virtual void GetWDInfoOnClick( wxCommandEvent& event );
		virtual void SetSettingsButtonOnClick( wxCommandEvent& event );
		virtual void miOptionsMIOnClick( wxCommandEvent& event );
		virtual void GetLogButtonOnClick( wxCommandEvent& event );
		virtual void ClearLogButtonOnClick( wxCommandEvent& event );

    void ShowWDInfo( bool ShowAll = true );
    void SendCmdGetInfo();

public:
    void OnSocketEvent( wxSocketEvent& event );

    void SetConnectionStatus( wxString StatusStr );
    void SetSetSettingsStatus(wxString StatusStr );
    void SetGetInfoStatus( wxString StatusStr );
    void SetLogItemsCountText( wxString StatusStr ) { LogItemsCountStaticText->SetLabel( StatusStr  ); }
    u32 GetWDGLogStartIdx() { return WDGLogStartEntrySpin->GetValue(); }

};


#endif // WATCHDOGCONNECTMAIN_H
