/***************************************************************
 * Name:      WatchdogClass.h
 * Purpose:   WatchDog class
 * Author:    Alexey Govorukhin (MasterAlexei@googlemail.com)
 * Created:   2010
 * Copyright: Alexey Govorukhin (http://www.fun-electronic.net/)
 * License:
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of the author nor the names of its contributors may
 *     be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 *  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 *  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 *  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 *  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *  SUCH DAMAGE.
 *
 **************************************************************************/

#ifndef __WATCHDOGCLASS_H
#define __WATCHDOGCLASS_H


#include <wx/list.h>

// #define WDG_TEST_VALUES

#include "GlobalData.h"


#define IP_ADDRESS_BUFF_LEN  20




class TWatchdog {
    bool fChanged;
    bool fNewData;
    bool fGettingLog;

  public:
    TWatchdog();
    ~TWatchdog();

    u32 Add( char * pSrcName );
    void Delete(u32 dwWDIdx);
    void SetName( u32 dwWDIdx, char * pSrcName );
    char * GetName( u32 dwWDIdx );
    void SetAddress( u32 dwWDIdx, char * pSrcAddress );
    char * GetAddress( u32 dwWDIdx );
    void SetPort( u32 dwWDIdx, u32 dwSrcPort );
    u32  GetPort( u32 dwWDIdx );
    u32  GetCount();

    TWDGData * GetWDGData( u32 dwWDIdx );
    // TWDGLog  * GetWDGLog( u32 dwWDIdx );

    bool GetChanged()   { return fChanged; }
    void ResetChanged() { fChanged = false;}
    void SetChanged()   { fChanged = true; }

    bool NewData()      { return fNewData; }
    void NewData(bool f){ fNewData = f;    }

    bool GettingLogProcess()         { return fGettingLog; }
    void GettingLogProcess( bool f ) { fGettingLog = f; }


};



#endif // __WATCHDOGCLASS_H
